# std::deque<T,Allocator>::end, std::deque<T,Allocator>::cend

From cppreference.com
< cpp‎ | container‎ | deque

iterator end(); | (1) | (noexcept since C++11)
const_iterator end() const; | (2) | (noexcept since C++11)
const_iterator cend() const noexcept; | (3) | (since C++11)

Returns an iterator to the element following the last element of the `deque`.

This element acts as a placeholder; attempting to access it results in undefined behavior.

### Parameters

(none)

### Return value

Iterator to the element following the last element.

### Complexity

Constant.

### Notes

libc++ backports `cend()` to C++98 mode.

### Example

Run this code

    #include <algorithm>
    #include <iostream>
    #include <numeric>
    #include <string>
    #include <deque>

    int main()
    {
        std::deque<int> nums{1, 2, 4, 8, 16};
        std::deque<std::string> fruits{"orange", "apple", "raspberry"};
        std::deque<char> empty;

        // Print deque.
        std::for_each(nums.begin(), nums.end(), [](const int n) { std::cout << n << ' '; });
        std::cout << '\n';

        // Sums all integers in the deque nums (if any), printing only the result.
        std::cout << "Sum of nums: "
                  << std::accumulate(nums.begin(), nums.end(), 0) << '\n';

        // Prints the first fruit in the deque fruits, checking if there is any.
        if (!fruits.empty())
            std::cout << "First fruit: " << *fruits.begin() << '\n';

        if (empty.begin() == empty.end())
            std::cout << "deque 'empty' is indeed empty.\n";
    }

Output:

    1 2 4 8 16
    Sum of nums: 31
    First fruit: orange
    deque 'empty' is indeed empty.

### See also

begincbegin (C++11) | returns an iterator to the beginning (public member function)
endcend (C++11)(C++14) | returns an iterator to the end of a container or array (function template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/deque/end&oldid=135174"